# Tendermint

Welcome to the Tendermint Core documentation!

Tendermint Core is a blockchain application platform; it provides the equivalent
of a web-server, database, and supporting libraries for blockchain applications
written in any programming language. Like a web-server serving web applications,
Tendermint serves blockchain applications.

More formally, Tendermint Core performs Byzantine Fault Tolerant (BFT)
State Machine Replication (SMR) for arbitrary deterministic, finite state machines.
For more background, see [What is
Tendermint?](introduction/what-is-tendermint.md).

To get started quickly with an example application, see the [quick start guide](introduction/quick-start.md).

To learn about application development on Tendermint, see the [Application Blockchain Interface](spec/abci).

For more details on using Tendermint, see the respective documentation for
[Tendermint Core](tendermint-core), [benchmarking and monitoring](tools), and [network deployments](networks).

## Contribute

To contribute to the documentation, see [this file](./DOCS_README.md) for details of the build process and
considerations when making changes.

## Version

This documentation is built from the following commit:
